<?php

/**
 * Inventestcego
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     SetForms Team <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Inventestcego extends DaoInventestcego
{


    const PENDENTE = 'P';
    const APROVADO = 'AP';
    const PROGRAMADO = 'PR';
    const PROGRAMADO_N_REALIZ = "'PN'";


    public static function alteraNaoProgramado($nrorg, $cdfilial, $dtcont){
        $db = TkDbAdapter::getWorkConnection();

        try {
            $result = $db->createQuery()
                ->update('INVENTESTCEGO')
                ->set('IDSITESTCEGO', self::PROGRAMADO_N_REALIZ)
                ->where("DTCONTAGEM = "."'$dtcont'")
                ->addWhere('CDFILIAL = '."'$cdfilial'")
                ->addWhere('NRORG = '."'$nrorg'");
            $db->execute($result);

        } catch (Exception $e) {
            tk_message(
            	'Error in class ('.__CLASS__.') function ('.__FUNCTION__.'): '.$e->getMessage()
            );
            return false;

        }
        return $result;
    }//end alteraNaoProgramado()


    /**
     *
     * @param $nrorg
     * @param $cdfilial
     * @param $dtcont
     * @return Doctrine Record
     */
    public function existeInventarioNaoRealizado($nrorg, $cdfilial, $dtcont){
        try {
            $obj = self::getObjectsByWhere(
                "CDFILIAL = ? AND DTCONTAGEM = ?
                AND IDSITESTCEGO = '".self::PROGRAMADO."' AND NRORG = ?",
                array(
                 $cdfilial,
                 $dtcont,
                 $nrorg,
                )
            );
            return $obj;
        } catch (Exception $e) {
            tk_message(
            	'Error in class ('.__CLASS__.') function ('.__FUNCTION__.') line '.__LINE__.': '.$e->getMessage(),TkMessage::TYPE_WARNING
            );
            return false;
        }
    }//end existeInventarioNaoRealizado()


    /**
     * Consulta se h algum inventrio pendente.
     *
     * @param integer $nrorg  Nmero da Organizao.
     * @param integer $filial Cdigo da Filial.
     * @param date    $data   Data de Processamento da Filial.
     *
     * @return Inventarios pendentes no dia imediatamente anterior a
     * data de processamento.
     */
     public static function consultaInventarioPendente($nrorg, $filial, $data){
        try {
            $db = TkDbAdapter::getWorkConnection();

            $subQuery_data_max = $db->createQuery()
                ->select('MAX(DTCONTAGEM) AS maximo')
                ->from('INVENTESTCEGO')
                ->where('CDFILIAL ='."'$filial'")
                ->addWhere('NRORG = '."'$nrorg'")
                ->addWhere("DTCONTAGEM < '$data'");

            $data_max = $subQuery_data_max->execute()->getFirst()->_values['maximo'];
            $data_max = explode(' ', $data_max);

            $db = TkDbAdapter::getWorkConnection();
            $objInventPendente = $db->createQuery()
                ->select('*')
                ->from('INVENTESTCEGO')
                ->where("NRORG = '$nrorg'")
                ->addWhere("CDFILIAL = '$filial'")
                ->addWhere("DTCONTAGEM = '$data_max[0]'")
                ->addWhere("IDSITESTCEGO = '".self::APROVADO."'")
                ->addWhere("IDSITUACEITEINV = '".self::PENDENTE."'");

            return $objInventPendente;

        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return;

        }

    }//end consultaInventarioPendente()


    /**
     * Executa procedure GERA_AJUSTE_INVCEGO.
     *
     * @static
     * @param  $params
     * @return bool
     */
    public static function procedureGeraAjuste($params){
        $db = TkDbAdapter::getWorkConnection();
        try {
            tk_call_procedure(
                'GERA_AJUSTE_INVCEGO',
                array(
                 array(
                  'value' => $params['CDFILIAL'],
                 ),
                 array(
                  'value' => $params['DTCONTAGEM'],
                 ),
                 array(
                  'value' => $params['CDALMOXARIFE'],
                 ),
                 array(
                  'value' => $params['CDLOCALESTOQ'],
                 ),
                 array(
                  'value' => $params['CDFILILANC'],
                 ),
                 array(
                  'value' => $params['NRLANCESTQ'],
                 ),
                 array(
                  'value' => $params['NRLANCRET'],
                 ),
                 array(
                  'value' => $params['NRRETIRADA'],
                 ),
                 array(
                  'value' => $params['NRCARDAPIO'],
                 ),
                 array(
                  'value' => $params['CDOPERADOR'],
                 ),
                )
            );
            $update = $db->createQuery()
                ->update('INVENTESTCEGO')
                ->set('IDINVGERAAJUSTE', "'S'")
                ->where("DTCONTAGEM = '".$params['DTCONTAGEM']."'")
                ->addWhere("CDFILIAL = '".$params['CDFILIAL']."'")
                ->addWhere("CDALMOXARIFE = '".$params['CDALMOXARIFE']."'")
                ->addWhere("CDLOCALESTOQ = '".$params['CDLOCALESTOQ']."'")
                ->addWhere("NRORG = '".$params['NRORG']."'");

            $update->execute();

        } catch(Exception $e) {
            tk_message('Error in class ('.__CLASS__.') function ('.__FUNCTION__.'): '.$e->getMessage());
            return false;
        }
        return true;
    }//end procedureGeraAjuste()


    /**
     * Atualiza situacao dos registros selecionados para "Aprovado".
     *
     * @static
     * @param  $dtcont - data de contagem
     * @param  $cdfilial - codigo da filial
     * @param  $cdalmox - codigo do almoxarifado
     * @param  $cdlocestoq - codigo do local de estoque
     * @return
     */
    public static function alteraSituacao($dtcont, $cdfilial, $cdalmox, $cdlocestoq, $nrorg, $sit){
        $db = TkDbAdapter::getWorkConnection();
        try {
            $result = $db->createQuery()
                ->update('INVENTESTCEGO')
                ->set('IDSITESTCEGO',"'$sit',")
                ->set('DTAPROVINVESTCE', "SYSDATE")
                ->where("DTCONTAGEM = "."'$dtcont'")
                ->addWhere('CDFILIAL = '."'$cdfilial'")
                ->addWhere('CDALMOXARIFE = '."'$cdalmox'")
                ->addWhere('CDLOCALESTOQ = '."'$cdlocestoq'")
                ->addWhere('NRORG = '."'$nrorg'");
                $db->execute($result);
        } catch(Exception $e) {
            tk_message(
            	'Error in class ('.__CLASS__.') function ('.__FUNCTION__.'): '.$e->getMessage()
            );
            return false;
        }
        return $result;
    }//end alteraSituacao()


    /**
     * Retorna query da consulta de inventario pendente.
     *
     * @static
     * @param  $cdfilial
     * @param  $dtproc
     * @param  $nrorg
     * @return string|void
     */
    public static function consultaQueryInventPendente($cdfilial, $dtproc, $nrorg){
        $db = TkDb::singleton();

        try{
            $sub_sql = $db->select()
                ->from('INVENTESTCEGO', array('MAX(DTCONTAGEM)'))
                ->where("CDFILIAL = '$cdfilial'")
                ->where("DTCONTAGEM < '$dtproc'")
                ->where("NRORG = '$nrorg'");

            $sql = $db->select()
                ->from(array('I' => 'INVENTESTCEGO' ) )
                ->join(array('P' =>'PARAMFILIAL'),'P.CDFILIAL = I.CDFILIAL','')
                ->where('I.CDFILIAL ='."'$cdfilial'")
                ->where('I.DTCONTAGEM = '."($sub_sql)")
                ->where("I.IDSITESTCEGO  = '".self::APROVADO."'")
                ->where("I.IDSITUACEITEINV = '".self::PENDENTE."'")
                ->where("P.IDINVESTCEGO = 'S'")
                ->where("I.NRORG = P.NRORG")
                ->where("I.NRORG = '$nrorg'");

        } catch(Exception $e) {
            tk_message(
            	'Error in class ('.__CLASS__.') function ('.__FUNCTION__.'): '.$e->getMessage()
            );
            return false;
        }

        return $sql->assemble();

    }//end consultaQueryInventPendente()


}//end class